src/main/java/dw2/tema6/project/model/Coordinator.java
package dw2.tema6.project.model;

import java.util.List;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;

import dw2.tema6.common.model.User;

@Entity
public class Coordinator extends User {
	
	@OneToMany(mappedBy="coordinator", fetch = FetchType.EAGER)
	@Fetch(FetchMode.SUBSELECT)
	private List<Project> projects;

	public List<Project> getProjects() {
		return projects;
	}

	public void setProjects(List<Project> projects) {
		this.projects = projects;
	}
	
	/**
	 * @return the running projects completion percentage based on {@link #projects} progress average ranging from 0 to 1
	 * @see Project
	 */
	@Transient
	public Float getProjectsProgress() {
		if (projects.size() == 0) return 0f;
		Float progressSum = 0f;
		for (Project project : projects) {
			progressSum += project.getProgress();
		}
		return progressSum / projects.size();
	}
}

src/main/java/dw2/tema6/system/model/Activity.java
package dw2.tema6.system.model;

import javax.persistence.Entity;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

@Entity
public class Activity {
	
	public enum Status {
		TO_DO,
		DOING,
		TO_APPROVE,
		REJECTED,
		DONE;
		
		public Boolean getCanBegin() {
			return this == Status.TO_DO || this == Status.REJECTED;
		}

		public Boolean getCanFinishOrCancel() {
			return this == Status.DOING;
		}

		public Boolean getCanApproveOrDisapprove() {
			return this == Status.TO_APPROVE;
		}
	}
	
	@Id
	@GeneratedValue
	private long code;
	private String description;
	private String estimatedDuration;
	
	@Enumerated
	private Status status = Status.TO_DO;
	
	@ManyToOne
	private Analyst analyst;
	
	@ManyToOne
	private System system;

	public long getCode() {
		return code;
	}

	public void setCode(long code) {
		this.code = code;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getEstimatedDuration() {
		return estimatedDuration;
	}

	public void setEstimatedDuration(String estimatedDuration) {
		this.estimatedDuration = estimatedDuration;
	}

	public Status getStatus() {
		return status;
	}

	public void setStatus(Status status) {
		this.status = status;
	}

	public Analyst getAnalyst() {
		return analyst;
	}

	public void setAnalyst(Analyst analyst) {
		this.analyst = analyst;
	}

	public System getSystem() {
		return system;
	}

	public void setSystem(System system) {
		this.system = system;
	}
	
	/**
	 * @return the completion percentage based on current {@link #status} ranging from 0 to 1
	 * @see Status
	 */
	@Transient
	public Float getProgress() {
		switch (status) {
		case DOING:
			return 1f / 3;
			
		case TO_APPROVE:
			return 2f / 3;
			
		case DONE:
			return 1f;

		default:
			return 0f;
		}
	}
}

src/main/java/dw2/tema6/common/controller/servicerequest/ServiceRequestListController.java
package dw2.tema6.common.controller.servicerequest;

import java.util.List;

import javax.faces.bean.ManagedBean;

import dw2.tema6.auth.controller.AuthController;
import dw2.tema6.common.model.ServiceRequest;
import dw2.tema6.common.model.ServiceRequestRepository;
import dw2.tema6.common.model.User;

@ManagedBean
public class ServiceRequestListController {

	public List<ServiceRequest> getMyRequests() {
		User user = AuthController.getLoggedUser();
		return user.getRequests();
	}

	public List<ServiceRequest> getPendingRequests() {
		return ServiceRequestRepository.getAllPendingRequests();
	}
}

src/main/java/dw2/tema6/project/controller/ProjectListController.java
package dw2.tema6.project.controller;

import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import dw2.tema6.auth.controller.AuthController;
import dw2.tema6.common.PersistenceManager;
import dw2.tema6.project.model.Coordinator;
import dw2.tema6.project.model.Project;

@ManagedBean
@ViewScoped
public class ProjectListController {
	public List<Project> getMyProjects() {
		Coordinator coordinator = (Coordinator) AuthController.getLoggedUser();
		return coordinator.getProjects();
	}
}

src/main/java/dw2/tema6/system/controller/ActivityListController.java
package dw2.tema6.system.controller;

import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import dw2.tema6.auth.controller.AuthController;
import dw2.tema6.common.PersistenceManager;
import dw2.tema6.project.model.Coordinator;
import dw2.tema6.project.model.Project;
import dw2.tema6.system.model.Activity;
import dw2.tema6.system.model.Analyst;

@ManagedBean
@ViewScoped
public class ActivityListController {
	public List<Activity> getMyActivities() {
		Analyst analyst = (Analyst) AuthController.getLoggedUser();
		return analyst.getActivities();
	}
}

src/main/webapp/WEB-INF/coordinator/activity_list.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:ui="http://java.sun.com/jsf/facelets">

	<h:dataTable value="#{systemDetailsController.system.activities}"
		var="act" border="1" cellpadding="2" cellspacing="0">
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.activity_code}" />
			</f:facet>
			<h:outputLabel value="#{act.code}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.description}" />
			</f:facet>
			<h:outputLabel value="#{act.description}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.estimated_duration}" />
			</f:facet>
			<h:outputLabel value="#{act.estimatedDuration}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.status}" />
			</f:facet>
			<h:outputLabel value="#{strings[act.status]}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.analyst}" />
			</f:facet>
			<h:outputLabel value="#{act.analyst.code} - #{act.analyst.name}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.progress}" />
			</f:facet>
			<h:outputLabel value="#{act.progress}">
				<f:convertNumber type="percent" />
			</h:outputLabel>
		</h:column>
		<h:column>
			<h:form>
				<h:link value="#{strings.details}"
					outcome="activity_details?faces-redirect=true">
					<f:param name="id" value="#{act.code}" />
				</h:link>
			</h:form>
		</h:column>
	</h:dataTable>
</ui:composition>

src/main/webapp/WEB-INF/coordinator/project_list.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:ui="http://java.sun.com/jsf/facelets">

	<h:dataTable value="#{projectListController.myProjects}" var="prj"
		border="1" cellpadding="2" cellspacing="0">>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.project_number}" />
			</f:facet>
			<h:outputLabel value="#{prj.number}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.description}" />
			</f:facet>
			<h:outputLabel value="#{prj.description}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.progress}" />
			</f:facet>
			<h:outputLabel value="#{prj.progress}">
				<f:convertNumber type="percent" />
			</h:outputLabel>
		</h:column>
		<h:column>
			<h:form>
				<h:link value="#{strings.details}"
					outcome="project_details?faces-redirect=true">
					<f:param name="id" value="#{prj.number}" />
				</h:link>
			</h:form>
		</h:column>
	</h:dataTable>
</ui:composition>

src/main/webapp/WEB-INF/coordinator/service_request_pending_list.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:ui="http://java.sun.com/jsf/facelets">

	<h:dataTable value="#{serviceRequestListController.pendingRequests}"
		var="sr" border="1" cellpadding="2" cellspacing="0">
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.request_number}" />
			</f:facet>
			<h:outputLabel value="#{sr.number}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.creation_date}" />
			</f:facet>
			<h:outputLabel value="#{sr.date}">
				<f:convertDateTime pattern="dd/MM/yyyy hh:mm" />
			</h:outputLabel>
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.description}" />
			</f:facet>
			<h:outputLabel value="#{sr.description}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.requester}" />
			</f:facet>
			<h:outputLabel value="#{sr.requester.code} - #{sr.requester.name}" />
		</h:column>
		<h:column>
			<h:form>
				<h:commandButton value="#{strings.create_project}"
					action="#{projectCreationController.create}">
					<f:setPropertyActionListener
						target="#{projectCreationController.serviceRequest}" value="#{sr}" />
				</h:commandButton>
			</h:form>
		</h:column>
	</h:dataTable>
</ui:composition>

src/main/webapp/WEB-INF/coordinator/system_list.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:ui="http://java.sun.com/jsf/facelets">

	<h:dataTable value="#{projectDetailsController.project.systems}"
		var="sys" border="1" cellpadding="2" cellspacing="0">
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.system_acronym}" />
			</f:facet>
			<h:outputLabel value="#{sys.acronym}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.name}" />
			</f:facet>
			<h:outputLabel value="#{sys.name}" />
		</h:column>
		<h:column>
			<f:facet name="header">
				<h:outputText value="#{strings.progress}" />
			</f:facet>
			<h:outputLabel value="#{sys.progress}">
				<f:convertNumber type="percent" />
			</h:outputLabel>
		</h:column>
		<h:column>
			<h:form>
				<h:link value="#{strings.details}"
					outcome="system_details?faces-redirect=true">
					<f:param name="id" value="#{sys.acronym}" />
				</h:link>
			</h:form>
		</h:column>
	</h:dataTable>
</ui:composition>